function GameField() {
	
	this.backColor = "#000000";
	this.width = 8;
	this.height = 8;
	
	this.maxIndex = this.width * this.height;
	this.board = new Array(this.maxIndex);
	this.blocks = ["T", "O", "L", "S", "Z", "I","K","J"];
	this.score = 0;
		
	this.block1 = [];
	this.block2 = [];
	this.block3 = [];
	
	this.hint = null;
	
	this.getRandomBlock = function() {
		return this.blocks[Math.floor(Math.random()*5)];
	};
	
	this.getBlock = function(x,y) {
		var b = this.board[this.index(x,y)];
		if (typeof(b) != "undefined" && b !== null && b !== "") {
			return this.board[this.index(x,y)];
		}
		return "";
	};
	
	this.clear = function(){
		this.block1 = [];
		this.block2 = [];
		this.block3 = [];
	};
	
	this.set_block = function(x,y, block) {
		this.board[ this.index(x,y) ] = block;
	};
	
	this.block_click = function(x,y) {
		if (this.getBlock(x, y) === "") {
			if (this.block1.length === 0) {
				var block = this.getRandomBlock();
				this.set_block(x, y, block);
				this.block1 = [block, x, y];
				this.checkLines();
				return true;
			}
			else 
				if (this.block2.length === 0) {
					this.block2 = [this.block1[0], x, y];
					this.set_block(x, y, this.block1[0]);
					this.checkLines();
					return true;
				}
			else 
				if (this.block3.length === 0) {
					var block = this.getRandomBlock();
					while(block == this.block1[0]) {
						block = this.getRandomBlock();	
					} 
					this.set_block(x, y, block);
					this.clear();
					
					this.checkLines();
					return true;
				}
		}
		return null;
	};
	
	this.index = function(column,row) {
	    return parseInt(column) + parseInt(row) + (this.width-1)*parseInt(row);
	};
	
	this.saveGame = function() {
		if (window.widget) {
			window.widget.setPreferenceForKey(this.board.toString(), 'gameArea');
			window.widget.setPreferenceForKey(this.score, 'gameScore');
		}
	};
	
	this.loadGame = function() {
		if (window.widget) {
			if (window.widget.preferenceForKey('gameArea')) {
				try {
					var b = window.widget.preferenceForKey('gameArea').split(",");
					if (b.length == this.maxIndex) {
						this.board = b;
					}
				} 
				catch (err) {
				}
			}
			
			if (window.widget.preferenceForKey('gameScore')) {
				try {
					if (parseInt(window.widget.preferenceForKey('gameScore'), 10)) {
						this.score = parseInt(window.widget.preferenceForKey('gameScore'), 10);
					}
				} 
				catch (err2) {
				}
			}
		}
	};
	
	this.checkLines = function() {
		var linesFound = 0;
		var removeThese = new Array();
		
		for(var y=0;y<this.height;y++) {
			for (var x = 0; x < this.width; x++) {
				var block = this.getBlock(x,y);
				if (block != null && block !== "") {
		
					if ( x+2 < this.width && this.getBlock(x+2,y) == block) {
						if (this.getBlock(x+1,y) == block) {
							linesFound++;
							removeThese.push(x +"," + y);
							removeThese.push((x+1) +"," + y);
							removeThese.push((x+2) +"," + y);
							if (x+3 < this.width && this.getBlock(x+3,y) == block) {
								linesFound++;
								removeThese.push((x+3) +"," + y);
								if (x+4 < this.width && this.getBlock(x+4,y) == block) {
									linesFound++;
									removeThese.push((x+4) +"," + y);
								}
							}
							
						}
					}
					if ( y+2 < this.height && this.getBlock(x,y+2) == block) {
						if (this.getBlock(x,y+1) == block) {
							linesFound++;
							removeThese.push(x +"," + y);
							removeThese.push(x +"," + (y+1));
							removeThese.push(x +"," + (y+2));
							if (y+3 < this.height && this.getBlock(x,y+3) == block) {
								linesFound++;
								removeThese.push(x +"," + (y+3));
								
								if (y+4 < this.height && this.getBlock(x,y+4) == block) {
									linesFound++;
									removeThese.push(x +"," + (y+4));
								}
							}
							
						}
					}
				}
			}
		}
		
		for( var i = 0; i < removeThese.length ; i++) {
			var split = removeThese[i].split(",");
			this.board[this.index(split[0],split[1])] = null;
		}
		
		for (var j = 0; j < this.board.length; j++) {
			if (this.board[j] == null || this.board[j] === "") {
				if (linesFound)
					this.score += 15 + (15*(linesFound-1)*linesFound);
				return true;
			}			
		}
		
		$("#gameOver").show();
		return false;
	};
	
	

}