var width;
var game;
var high_score = 0;
var isLandscape;
var hintCount = 0;

function changeOrientation(){
	$("#orientation").remove();
	if ($(window).width() < 400) {
		$("head").append('<link rel="stylesheet" id="orientation" type="text/css" href="css/portrait.css" />');
	}
	else {
		$("head").append('<link rel="stylesheet" id="orientation" type="text/css" href="css/landscape.css" />');
	}
}

function resizeUI() {
	var height = $(window).height();
	width = $(window).width();
	if(width>height) {
		isLandscape = true;
	} else {
		// Portrait
		isLandscape = false;		
	}	
}

function click(block) {
	var block_id = $(block).attr("id").substring(1);
	var x = parseInt(block_id.split("_")[0],10);
	var y = parseInt(block_id.split("_")[1],10);
	
	if (x >= 0 && y >= 0) {
		var found = game.block_click(x, y);
		if (found === null) {
			
		}
		else {
			tactileFeedback();
			draw_stat();
			draw_board();	
		}
	}
}

function bind_buttons()
{
	$(".b").click( function(e) {
		click(this);
	});
	
	$("#newGame").click( function() {
		reset_game();
		tactileFeedback();
		$(this).animate({color:"white"},1000);
		$(this).animate({color:"black"},1000);
		$("#hint").css('opacity','1');
		$("#hint").show();
	});
	
	$("#moreGames").click( function() {
		tactileFeedback();
		var urlEncoded = encodeURI("http://store.ovi.com/publisher/jiikoo/");
	    // Open the HTML page
	    widget.openURL(urlEncoded);
		
	});

	$("#saveGame").click( function() {
		tactileFeedback();
		game.saveGame();
		$(this).animate({color:"white"},1000);
		$(this).animate({color:"black"},1000);
		$("#hint").css('opacity','0.2');
		$("#hint").hide();
		hintCount = 0;
	});
	$("#exit").click( function() {
		tactileFeedback();
		window.close();
	});
	$("#hint").click( function() {
		if ($(this).css('opacity') != "0.2") {
			if (game.hint !== null) {
				game.score = game.score - 150;
				draw_stat();
				var points = game.hint.split(",");
				click($("#b" + points[0] + "_" + points[1]));
			}
			$(this).animate({
				color: "white"
			}, 1000);
			$(this).animate({
				color: "black"
			}, 1000);
		}
	});
	
	$("#loadGame").click( function() {
		tactileFeedback();
		$(this).animate({color:"white"},1000);
		$(this).animate({color:"black"},1000);
		$("#gameOver").hide();
		game = new GameField();
		game.loadGame();
		draw_stat();
		$("#board").html('');
		draw_board();	
		$("#hint").css('opacity','0.2');
		$("#hint").hide();
		hintCount = 0;
		
	});
	
	$(".b").hover(
		function() {
			
		},
		function() {
			
		}
	);
}

function draw_board() {
	var blocks = 0;
	var new_html = "";
	var lastBlock = -1;
	var gameOver = true;
	
	for(var j=0;j<game.height;j++) {
		for(var i=0;i<game.width;i++) {
			var block = game.getBlock(i,j);
			if (block != "") {
				new_html += "<div id='b" + i + "_" + j + "' class='b hasBlock " + block + "'> </div>";
			}
			else {
				new_html += "<div id='b" + i + "_" + j + "' class='b'> </div>";
			}
		}
	}
	$("#board").html(new_html);
	$(".b").click( function(e) {
		click(this);
	});
	return blocks;
}
function reset_game() {
	$("#gameOver").hide();
	game = new GameField();
	draw_stat();
	$(".b").attr('class','b');
}

function draw_stat() {
	$("#score").text(game.score);

	if(game.score>high_score) {
		high_score = game.score;
		
		if (window.widget) {
			window.widget.setPreferenceForKey(game.score, 'high');
		}
	}
	$("#high_score").text(high_score);
}

function init() {
	try {
		window.menu.hideSoftkeys();
	}catch(e) {}
	document.body.style.webkitUserSelect = "none";
	if (window.widget) {
		high_score = window.widget.preferenceForKey('high');
	}
	game = new GameField();
	
	if(high_score==null) {
		high_score = 0;
	}
	
	bind_buttons();
	draw_stat();
	sysinfo = document.getElementById("sysinfo");
	sysinfo.lightinfiniteduration;
	
	if (sysinfo.vibrasettings != "1") {
		var systemServiceObj = device.getServiceObject("Service.SysInfo", "ISysInfo");
		var on = {
			Status: 1
		};
		
		var setParameters = {
			Entity: "General",
			Key: "VibraActive",
			SystemData: on
		};
		try {
			var result = systemServiceObj.ISysInfo.SetInfo(setParameters);
		} 
		catch (ex) {
		}
	}
}

function tactileFeedback()
{
	sysinfo.startvibra(30, 50);
}

var sysinfo = null;